//+------------------------------------------------------------------+
//|                                              5min_Indicator8.mq4 |
//|                                     Ferrari Green Associates LTD |
//|                                    https://www.Ferrari-Green.com |
//+------------------------------------------------------------------+
#property copyright "Ferrari Green Associates LTD"
#property link      "https://www.Ferrari-Green.com"
#property version   "1.00"
#property strict
#property indicator_chart_window

#property indicator_buffers 4
extern int MaxBars= 1000;

//---Indicator Colours
#property indicator_color1 clrGreen//up arrow
#property indicator_color2 clrRed//down arrow
#property indicator_color3 clrCrimson//BollingerUpper
#property indicator_color4 clrCrimson//BollingerLower


//---Indicator Width
#property indicator_width1 2
#property indicator_width2 2

#include <WinUser32.mqh>
extern bool show=true;//Show Indicators?

double UpArrow[];
double DownArrow[];
double BollingerUpper[];
double BollingerLower[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {

//--- indicator buffers mapping
   SetIndexBuffer(0,UpArrow);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexLabel(0,"Buy Signal.");
//---
   SetIndexBuffer(1,DownArrow);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);
   SetIndexLabel(1,"Sell Signal.");
//---
   SetIndexBuffer(2,BollingerUpper);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexLabel(2,"BollingerUpper.");
//---
   SetIndexBuffer(3,BollingerLower);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexLabel(3,"BollingerUpper.");
//---   

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---for loop
   int counted_bars=IndicatorCounted();
   int limit= Bars-counted_bars;
   for(int i=1;i<MaxBars-1;i++)
     {
      double BolUpper=iBands(NULL,0,20,3,0,PRICE_MEDIAN,MODE_UPPER,i);
      double BolLower=iBands(NULL,0,20,3,0,PRICE_MEDIAN,MODE_LOWER,i);
      bool flag=false;
      //---
      
      double PriceClose=(Close[i]);
      double PriceCloseBack=(Close[i+1]);
      double PriceMedian=(High[i]+Low[i])/2;
      double PriceMedianBack=(High[i+1]+Low[i+1])/2;
      double PriceLow=(Low[i]);
      double PriceLowBack=(Low[i+1]);
      double PriceOpen=(Open[i]);
      double PriceOpenBack=(Open[i+1]);
      
      if(show==true)
        {
         BollingerUpper[i]=BolUpper;
         BollingerLower[i]=BolLower;
        }
      if(High[i]<High[i+1])
         if(High[i+1]>BolUpper)
           {
            flag=DrawLine("Line_"+(string)i,Time[i+1],High[i+1],Time[i],High[i]);
           }
      if(PriceMedianBack<flag && PriceMedian>flag)
        {
         UpArrow[i]=Open[i];
        }
//      if(Low[i]>Low[i+1])
//         if(Low[i+1]<BolLower)
           {
//            flag=DrawLine("Line_"+(string)i,Time[i+1],High[i+1],Time[i],High[i]);
           }
//      if(Price>flag)
        {
//         DownArrow[i]=Open[i];
        }
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
bool DrawLine(string n,datetime t1,double p1,datetime t2,double p2,color clr=clrYellow,string dscr="",bool ray=true,int stl=STYLE_SOLID,int wdt=1)
  {

   if(ObjectFind(n)>=0) ObjectDelete(n);
   if(!ObjectCreate(0,n,OBJ_TREND,0,t1,p1,t2,p2))  return(false);
   bool ok=ObjectSet(n,OBJPROP_COLOR,clr);
   ok = ok && ObjectSet(n,OBJPROP_STYLE,stl);
   ok = ok && ObjectSet(n, OBJPROP_RAY, ray);
   ok = ok && ObjectSet(n,OBJPROP_WIDTH,wdt);
   ok = ok && ObjectSetText(n,dscr,10);
   WindowRedraw();
   return(ok);
  }

